<?php

/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2012 - 2016 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.joomlathat.com
# Technical Support:	Forum - http://www.joomlathat.com/support
-------------------------------------------------------------------------*/

/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgInvoicessearchVirtuemart extends JPlugin {

	function plgInvoicessearchVirtuemart(& $subject, $config) {

		$plugin = JPluginHelper::getPlugin('invoicessearch','virtuemart');
		$this->params = new JRegistry( $plugin->params );
		
		$this->lang_code = $this->params->get('lang', 'en_gb') ;

		parent::__construct($subject, $config);

	}
	
	var $component = "com_virtuemart" ;
	var $lang_code = "en_gb" ;
	var $params = null ;
	
	function onSearchItems($keywords){
		
		$db = JFactory::getDBO();
		
		$where_clause = array();
		
		$where_clause[] = ' ( lan.product_name LIKE "%'.$keywords.'%" OR lan.product_s_desc LIKE "%'.$keywords.'%" OR tei.product_sku LIKE "%'.$keywords.'%" ) ';
		
		// Build the where clause of the content record query
		$where_clause = (count($where_clause) ? ' WHERE '.implode(' AND ', $where_clause) : '');
		
		$query = ' SELECT tei.virtuemart_product_id AS id, tei.virtuemart_product_id AS product_id, tei.product_sku AS sku, lan.product_name As name, lan.product_s_desc AS `description`, pri.product_price AS value, "'.$this->component.'" AS component,  "'.$this->component.'" AS external_type, 1 AS amount  '
				.' FROM #__virtuemart_products as tei '
				.' LEFT JOIN #__virtuemart_products_'.$this->lang_code.' AS lan ON lan.virtuemart_product_id = tei.virtuemart_product_id '
				.' LEFT JOIN #__virtuemart_product_prices AS pri ON pri.virtuemart_product_id = tei.virtuemart_product_id '
		 		.$where_clause 
		 		.' LIMIT 20 ';
		$db->setQuery($query);
		$items = $db->loadObjectList();
		
		//echo $query;
		
		$return = new stdClass();
		$return->component = $this->component ;
		$return->items = $items ;
		
		return $return ;
		
	}
	
	function onSearchContacts($keywords){
		
		$db = JFactory::getDBO();
		
		$where_clause = array();
		
		$where_clause[] = ' ( u.name LIKE "%'.$keywords.'%" OR u.username LIKE "%'.$keywords.'%" OR u.email LIKE "%'.$keywords.'%"  OR cou.first_name LIKE "%'.$keywords.'%"  OR cou.last_name LIKE "%'.$keywords.'%"  OR cou.company LIKE "%'.$keywords.'%" ) ';

		$where_clause[] = ' cou.virtuemart_user_id IS NOT NULL ' ;
		
		// Build the where clause of the content record query
		$where_clause = (count($where_clause) ? ' WHERE '.implode(' AND ', $where_clause) : '');
		
		$query = ' SELECT cou.virtuemart_userinfo_id AS id '
				//.' CONCAT("'.$this->component.'",",",cou.virtuemart_userinfo_id) AS id '
				.' FROM #__virtuemart_userinfos AS cou '
				.' LEFT JOIN #__users AS u ON cou.virtuemart_user_id = u.id '
		 		.$where_clause ;
		$db->setQuery($query);
		$items = $db->loadObjectList();
		
		$i = 0 ;
		foreach($items as $item){
			$theuser = $this->onObtainContact($item->id);
			$items[$i] = $theuser ;
			$i++;
		}
		//print_r($items);die;
		$return = new stdClass();
		$return->component = $this->component ;
		$return->items = $items ;
		
		return $return ;
		
	}
	
	function onObtainContact($id){
		
		$db = JFactory::getDBO();

		$query = ' SELECT u.* '
				.' FROM #__users AS u '
				.' WHERE u.id = '. $id ;
		$db->setQuery($query);
		$usuari = $db->loadObject();
		
		$query = ' SELECT va.*, u.email, u.username '
				.' FROM #__virtuemart_userinfos AS va '
				.' LEFT JOIN #__users AS u ON u.id = va.virtuemart_user_id '
				.' WHERE va.virtuemart_userinfo_id = '. $id ;
		$db->setQuery($query);
		$vmuser = $db->loadObject();

		$country = "";
		$state = "";

		$item = new stdClass();

		if(!empty($vmuser)){
		
			if($vmuser->virtuemart_country_id){
				$query = " SELECT country_name FROM #__virtuemart_countries WHERE virtuemart_country_id = ".$vmuser->virtuemart_country_id;
				$db->setQuery($query);
				$country = $db->loadResult();
			}
			
			if($vmuser->virtuemart_state_id){
				$query = " SELECT state_name FROM #__virtuemart_states WHERE virtuemart_state_id = ".$vmuser->virtuemart_state_id;
				$db->setQuery($query);
				$state = $db->loadResult();
			}

			$item->name = $vmuser->first_name . " " . $vmuser->last_name ;
			$item->to_name = $item->name ;
			$item->to_company = $vmuser->company ;
			$item->to_email = $vmuser->email ;
			$item->to_address = $vmuser->address_1 . " " .$vmuser->address_2 ;
			$item->id = 0 ;
			$item->to_city = $vmuser->city ;
			$item->to_state = $state ;
			$item->to_country = $country ;
			$item->to_zipcode = $vmuser->zip ;
			$item->to_vatid = "";
			$item->user_id = "" ;
			$item->username = $vmuser->username ;
			$item->phone = $vmuser->phone_1 ;

			$item->component = $this->component ;

			$item->vincular_cliente = $item->to_name ;
			$item->joomla_user_id = $vmuser->virtuemart_user_id ;

		}
		
		return $item ;
		
	}

}
